﻿Imports ThinkGeo.MapSuite
Imports ThinkGeo.MapSuite.Layers
Imports ThinkGeo.MapSuite.Styles
Imports ThinkGeo.MapSuite.Shapes
Imports ThinkGeo.MapSuite.Drawing
Imports ThinkGeo.MapSuite.WinForms

Public Class Form1
	Private WithEvents arcGisLayer As New CustomArcGisRestLayer()
	Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
		mAddRestLayer()
		WinformsMap1.Refresh()
	End Sub
	Private Sub mAddRestLayer()
		Const sampleServerUri As String = "http://sampleserver1.arcgisonline.com/ArcGIS/rest/services/Specialty/ESRI_StateCityHighway_USA/MapServer"
		Const testServerUri As String = "https://gis.apfo.usda.gov/arcgis/rest/services/Base_Maps/Base_Map/MapServer"

		WinformsMap1.MapUnit = GeographyUnit.DecimalDegree

		' documentation for ArcGIS Server REST API can be found at:  http://resources.arcgis.com/en/help/arcgis-rest-api/ , V 9.3 : http://resources.esri.com/help/9.3/arcgisserver/apis/rest/index-9-3.html

		' Specifies the uri of the web service.
		'arcGisLayer.ServerUri = New Uri($"{testServerUri}/export")
		arcGisLayer.ServerUri = New Uri($"{testServerUri}/export")
		arcGisLayer.Parameters.Add("layers", "show:1,2")

		' Sets our parameters for image format.
		arcGisLayer.Parameters.Add("format", "png")
		'arcGisLayer.ImageFormat = ArcGISServerRestLayerImageFormat.Png   'we can use the property 'ImageFormat' instead of the 'format' in parameters. When they coexist, the property is perferred.

		' Sets our parameters for transparency.
		arcGisLayer.Parameters.Add("transparent", "true")

		Dim LayerOverlay As New LayerOverlay()
		LayerOverlay.Layers.Add("ArcGISServerRestLayer", arcGisLayer)

		WinformsMap1.Overlays.Add("LayerOverlay", LayerOverlay)
		WinformsMap1.CurrentExtent = New RectangleShape(-130.1, 59.3, -65.3, 17.7)
		'WinformsMap1.CurrentExtent = New RectangleShape(-20037700, 29754728.7505, 39958128.7505, -10242490.4165)

	End Sub

	Private Sub arcGisLayer_SendingWebRequest(sender As Object, e As SendingWebRequestEventArgs) Handles arcGisLayer.SendingWebRequest
		Debug.WriteLine(e.WebRequest.RequestUri)
	End Sub

	Private Sub arcGisLayer_DrawingException(sender As Object, e As DrawingExceptionLayerEventArgs) Handles arcGisLayer.DrawingException
		Debug.WriteLine(e.Exception.Message)
	End Sub
End Class
